/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.tables.records.TUmlsMrconsoRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TUmlsMrconso extends TableImpl<TUmlsMrconsoRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_umls_mrconso</code>
     */
    public static final TUmlsMrconso T_UMLS_MRCONSO = new TUmlsMrconso();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TUmlsMrconsoRecord> getRecordType() {
        return TUmlsMrconsoRecord.class;
    }

    /**
     * The column <code>common_dd.t_umls_mrconso.cui</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> CUI = createField(DSL.name("cui"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.lat</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> LAT = createField(DSL.name("lat"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.lui</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> LUI = createField(DSL.name("lui"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.sui</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> SUI = createField(DSL.name("sui"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.aui</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> AUI = createField(DSL.name("aui"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.sab</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> SAB = createField(DSL.name("sab"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.tty</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> TTY = createField(DSL.name("tty"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.str</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> STR = createField(DSL.name("str"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.t_umls_mrconso.dn</code>.
     */
    public final TableField<TUmlsMrconsoRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private TUmlsMrconso(Name alias, Table<TUmlsMrconsoRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TUmlsMrconso(Name alias, Table<TUmlsMrconsoRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_umls_mrconso</code> table reference
     */
    public TUmlsMrconso(String alias) {
        this(DSL.name(alias), T_UMLS_MRCONSO);
    }

    /**
     * Create an aliased <code>common_dd.t_umls_mrconso</code> table reference
     */
    public TUmlsMrconso(Name alias) {
        this(alias, T_UMLS_MRCONSO);
    }

    /**
     * Create a <code>common_dd.t_umls_mrconso</code> table reference
     */
    public TUmlsMrconso() {
        this(DSL.name("t_umls_mrconso"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.T_SHIP_MRCONSO_DN_IDX, Indexes.T_SHIP_MRCONSO_STR_IDX);
    }

    @Override
    public TUmlsMrconso as(String alias) {
        return new TUmlsMrconso(DSL.name(alias), this);
    }

    @Override
    public TUmlsMrconso as(Name alias) {
        return new TUmlsMrconso(alias, this);
    }

    @Override
    public TUmlsMrconso as(Table<?> alias) {
        return new TUmlsMrconso(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TUmlsMrconso rename(String name) {
        return new TUmlsMrconso(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TUmlsMrconso rename(Name name) {
        return new TUmlsMrconso(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TUmlsMrconso rename(Table<?> name) {
        return new TUmlsMrconso(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso where(Condition condition) {
        return new TUmlsMrconso(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TUmlsMrconso where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TUmlsMrconso where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TUmlsMrconso where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TUmlsMrconso where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TUmlsMrconso whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
